import _extends from "@babel/runtime/helpers/esm/extends";
import { isClient } from './config.js';
import { decorateContextWithNeededData, getDefaultProperties } from './segmentWrapper.js';
var MPI_PATCH_FIELD = '__mpi_patch';
function monkeyPatchAnalyticsTrack() {
  var originalTrack = window.analytics.track;
  window.analytics.track = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var event = args[0],
      properties = args[1],
      contextFromArgs = args[2],
      fn = args[3];
    var newProperties = _extends({}, getDefaultProperties(), properties);
    decorateContextWithNeededData({
      context: contextFromArgs,
      event: event
    }).then(function (context) {
      originalTrack.call(window.analytics, event, newProperties, context, fn);
    });
    return window.analytics;
  };
  // add a flag to the patched analytics so we don't patch this twice
  window.analytics[MPI_PATCH_FIELD] = true;
}
if (isClient) {
  if (!window.analytics) {
    console.warn('Segment Analytics is not loaded so patch is not applied.');
  } else if (!window.analytics[MPI_PATCH_FIELD]) {
    window.analytics.initialized ? monkeyPatchAnalyticsTrack() : window.analytics.ready(monkeyPatchAnalyticsTrack);
  }
}