function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
export function readCookie(cookieName) {
  var re = new RegExp(cookieName + '=([^;]+)');
  var value = re.exec(document.cookie);
  return value !== null ? unescape(value[1]) : null;
}
var ONE_YEAR = 31536000;
var DEFAULT_PATH = '/';
var DEFAULT_SAME_SITE = 'Lax';
export function saveCookie(cookieName, data, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$maxAge = _ref.maxAge,
    maxAge = _ref$maxAge === void 0 ? ONE_YEAR : _ref$maxAge,
    _ref$path = _ref.path,
    path = _ref$path === void 0 ? DEFAULT_PATH : _ref$path,
    _ref$reduceDomain = _ref.reduceDomain,
    reduceDomain = _ref$reduceDomain === void 0 ? true : _ref$reduceDomain,
    _ref$sameSite = _ref.sameSite,
    sameSite = _ref$sameSite === void 0 ? DEFAULT_SAME_SITE : _ref$sameSite;
  var domain = reduceDomain ? toCookieDomain() : window.location.hostname;
  var cookieValue = [cookieName + "=" + data, "domain=" + domain, "path=" + path, "max-age=" + maxAge, "SameSite=" + sameSite].join(';');
  document.cookie = cookieValue;
}

/**
 * Reduces the domain to main domain name
 * Examples:
 *   - www.fotocasa.es -> .fotocasa.es
 *   - www.motos.coches.net -> .coches.net
 *   - www.jobisjob.co.uk -> .jobisjob.co.uk
 *
 * @param {String} domain
 * @returns {String} dot + main domain
 */
var toCookieDomain = function toCookieDomain(domain) {
  if (domain === void 0) {
    domain = window.location.hostname || '';
  }
  var DOT = '.';
  var hostDomainParts = domain.split(DOT).reverse();
  if (hostDomainParts.length === 1) {
    return hostDomainParts[0];
  }
  var cookieDomainParts = [];
  for (var _iterator = _createForOfIteratorHelperLoose(hostDomainParts), _step; !(_step = _iterator()).done;) {
    var part = _step.value;
    cookieDomainParts.push(part);
    if (part.length > 3) break;
  }
  return "" + DOT + cookieDomainParts.reverse().join(DOT);
};