// @ts-check

/**
 * Use this module to store and retrieve data from localStorage or sessionStorage
 * @param {object} params
 * @param {string} params.key
 * @param {'getItem'|'removeItem'|'setItem'=} params.method
 * @param {'localStorage'|'sessionStorage'=} params.type
 * @param {string=} params.value
 * @returns {string|void}
 */
export var storage = function storage(_ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'localStorage' : _ref$type,
    _ref$method = _ref.method,
    method = _ref$method === void 0 ? 'getItem' : _ref$method,
    key = _ref.key,
    value = _ref.value;
  try {
    return window[type][method](key, value);
  } catch (e) {
    console.error(e);
  }
};